#ifndef __TFT_H
#define __TFT_H
#include"sys.h"
#include"delay.h"

extern const unsigned char ascii[95][16];

#define cs PCout(9)
#define rs PCout(8)
#define wr PCout(7)
#define rd PCout(6)

void init_lcd(void);
void init_id(void);
void wr_com(u8);
void wr_da(u16);
void wr_reg(u8, u16);

u16 read_point(u16, u16 y);
u16 LCD_BGR2RGB(u16 c);	 		//ҵҺIDΪ9328дȥRGB565BGR565Ҫת

void LCD_Clear(u16 color);
void set_point(u16 x, u16 y, u16 color);
void dis_num(u16, u16, u16, u16, u8);
void dis_char(u16, u16, u16, u16, u8);
void dis_str(u16, u16, u16, u16, u8 *);
void Set_Window(u16 x0, u16 y0, u16 x1, u16 y1);

#endif
