#include"TOUCH.h"

void WriteComTouch(u8 com)
{
	u8 i,temp;
	
	DCLK=0;
	for (i=0;i<8;i++)
	{
		temp=com & 0x80;  //λȡBit 
		if (temp==0)
		{
			DIN=0;
		}
		else
		{ 
			DIN=1;
		}
			com<<=1;
			DCLK=0;    //׵ƽ
			DCLK=1;    //غ ADS7843  
	}
}

u16 ReadDaTouch(void)
{
	u8 i;
	u8 j;
	u16 data;
	
	for(j=0;j<0x1;j++);                   
	DCLK=1;                              
	DCLK=0; 
	for (i=0;i<16;i++)
	{
		data<<=1;
		DCLK=1;
		for(j=0;j<0x1;j++);
		DCLK=0;                        
		if (DOUT)data++;
	}
	  data>>=4; 
	return (data);
}

void StartTouch(void)
{
	DCLK = 0;

	RCC->APB2ENR |= 1 << 4;
	GPIOC->CRL &= 0xffff0000;
	GPIOC->CRL |= 0x00003883;
	GPIOC->CRH &= 0xff0fffff;
	GPIOC->CRH |= 0x00300000;

	CS = 1;
	DIN = 1;
	DCLK = 1;
	CS = 0;							  
}

u8 ReadXYDataTouch(u16 *x, u16 *y, u8 flag)
{
	u16 x1, y1;
	u16 x2, y2;
	u16 xda, yda;

	//*******************		
	WriteComTouch(CMD_RDX);
	x1 = ReadDaTouch();
	WriteComTouch(CMD_RDY);
	y1 = ReadDaTouch();
	//*******************
	WriteComTouch(CMD_RDX);
	x2 = ReadDaTouch();
	WriteComTouch(CMD_RDY);
	y2 = ReadDaTouch();
	//********************
	if (x1 < x2)
		if((x2 - x1) > ERR_RANGE)
			return 1;
	else
		if(x1 - x2 > ERR_RANGE)
			return 1;

	if (y1 < y2)
		if(y2 - y1 > ERR_RANGE)
			return 1;
	else
		if(y[0] - y[1] > ERR_RANGE)
			return 1;
	//*********************
	if (flag == 1)
	{
		xda = (u16)((x2 + x1)/2.0);
		yda = (u16)((y2 + y1)/2.0);

		*x = (u16)((yda - 200)/(15.0));
		*y = (u16)((3900 - xda)/(11.0));
	}
	else
	{
		*x = (u16)((x2 + x1)/2.0);
		*y = (u16)((y2 + y1)/2.0);
	}
	return 0;
}
