//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//汾V1.0
//Copyright(C) ¬ 20012-2022
//All rights reserved
//********************************************************************************
#include"MYGUI.h"

TFTINFO_STRUCT TFTINFO;		//GUIϢ
/***************************************************************
FUNCTION:GUIʼ
PARAM:
RETURN:
****************************************************************/
void GUI_Init(void)
{
	DRIVER_TFT_Init();
	TFTINFO.BKCOLOR = 0x0000;
	TFTINFO.COLOR = 0xFFFF;
	TFTINFO.FontSizeL=8;
	TFTINFO.FontSizeW=16;
	GUI_Clear();
}
/***************************************************************
FUNCTION:GUIǰɫ
PARAM:ɫ
RETURN:
****************************************************************/
void GUI_Set_Color(unsigned int color)
{
	TFTINFO.COLOR = color;
}
/***************************************************************
FUNCTION:GUIɫ
PARAM:ɫ
RETURN:
****************************************************************/
void GUI_Set_BKColor(unsigned int color)
{
	TFTINFO.BKCOLOR = color;
}
/***************************************************************
FUNCTION:GUIõǰ
PARAM:x꣬y
RETURN:
****************************************************************/
void GUI_SetPos(unsigned int x, unsigned int y)
{
	if(x<240 && y<320)
	{
		TFTINFO.Xpos=x;
		TFTINFO.Ypos=y;
	}
}
/***************************************************************
FUNCTION:GUIõǰ
PARAM:xָ룬yָ
RETURN:
****************************************************************/
void GUI_GetPos(unsigned int *x, unsigned int *y)
{
	*x = TFTINFO.Xpos;
	*y = TFTINFO.Ypos;
}
/***************************************************************
FUNCTION:GUIԱɫ
PARAM:
RETURN:
****************************************************************/
void GUI_Clear(void)
{
	DRIVER_TFT_Clear(TFTINFO.BKCOLOR);
}
/***************************************************************
FUNCTION:GUIǰɫˢĻ
PARAM:
RETURN:
****************************************************************/
void GUI_Fill(void)
{
	DRIVER_TFT_Clear(TFTINFO.COLOR);
}
/***************************************************************
FUNCTION:GUIԱɫο
PARAM:Ͻ꣬½
RETURN:
****************************************************************/
void GUI_ClearRect(GUI_POINT_STRUCT POINT1, GUI_POINT_STRUCT POINT2)
{
	u16 i = 0, Len = 0;
	if((POINT1.x <= POINT2.x) && (POINT1.y <= POINT2.y))		//Ҫ򻭾
	{
		Len = POINT2.x - POINT1.x + 1;
		Len = (POINT2.y - POINT1.y + 1)*Len;
		DRIVER_TFT_WINDOW(POINT1.x, POINT1.y, POINT2.x, POINT2.y);
		for(i=0; i<Len; i++)
			DRIVER_TFT_DA(TFTINFO.BKCOLOR);
		DRIVER_TFT_WINDOW(0, 0, TFT_WIDTH, TFT_HEIGHT);	
	}
}
/***************************************************************
FUNCTION:GUIɫο
PARAM:Ͻ꣬½
RETURN:
****************************************************************/
void GUI_FillRect(GUI_POINT_STRUCT POINT1, GUI_POINT_STRUCT POINT2)
{
	u16 i = 0, Len = 0;
	if((POINT1.x <= POINT2.x) && (POINT1.y <= POINT2.y))		//Ҫ򻭾
	{
		Len = POINT2.x - POINT1.x + 1;
		Len = (POINT2.y - POINT1.y + 1)*Len;
		DRIVER_TFT_WINDOW(POINT1.x, POINT1.y, POINT2.x, POINT2.y);
		for(i=0; i<Len; i++)
			DRIVER_TFT_DA(TFTINFO.COLOR);
		DRIVER_TFT_WINDOW(0, 0, TFT_WIDTH, TFT_HEIGHT);	
	}
}
/***************************************************************
FUNCTION:GUIˮƽ,
PARAM:x, y(ˮƽ߸߶), ߳
RETURN:
****************************************************************/
void GUI_DrawLineH(GUI_POINT_STRUCT POINT, unsigned int Len)
{
	unsigned int i;
	
	for (i=0;i<Len;i++)
	{
		DRIVER_TFT_POINT(POINT.x+i, POINT.y, TFTINFO.COLOR);
	}	
}
/***************************************************************
FUNCTION:GUIֱ,
PARAM:x, y, ߳
RETURN:
****************************************************************/
void GUI_DrawLineV(unsigned int x, unsigned int y, unsigned int Len)
{
	unsigned int i;
	
	for (i=0;i<Len;i++)
	{
		DRIVER_TFT_POINT(x, y+i, TFTINFO.COLOR);
	}	
}
/***************************************************************
FUNCTION:GUIԪ
PARAM:x, y, 뾶
RETURN:
****************************************************************/
void GUI_DrawCircle(GUI_POINT_STRUCT POINT, unsigned int R)
{
	int a, b;
	int di;
	u16 x = POINT.x, y = POINT.y;

	a = 0;
	b = R;
	di = 3 - (R << 1);
	while(a < b)
	{
		DRIVER_TFT_POINT(x - b, y - a, TFTINFO.COLOR);
		DRIVER_TFT_POINT(x + b, y - a, TFTINFO.COLOR);
		DRIVER_TFT_POINT(x - a, y + b, TFTINFO.COLOR);
		DRIVER_TFT_POINT(x - b, y - a, TFTINFO.COLOR);
		DRIVER_TFT_POINT(x - a, y - b, TFTINFO.COLOR);
		DRIVER_TFT_POINT(x + b, y + a, TFTINFO.COLOR);
		DRIVER_TFT_POINT(x + a, y - b, TFTINFO.COLOR);
		DRIVER_TFT_POINT(x + a, y + b, TFTINFO.COLOR);
		DRIVER_TFT_POINT(x - b, y + a, TFTINFO.COLOR);
		a++;
		if (di < 0)
		{
			di += 4 * a + 6;
		}
		else
		{
			di += 10 + 4 * (a - b);
			b--;
		}
		DRIVER_TFT_POINT(x + a, y + b, TFTINFO.COLOR);
	}	
}
/***************************************************************
FUNCTION:GUIǰʾַ
PARAM:ַ
RETURN:
****************************************************************/
void GUI_DisStr(unsigned char* str)
{
	unsigned int i=0;

	while(str[i]!='\0')
	{
		if(TFTINFO.Xpos>=240)
		{
			TFTINFO.Ypos+=TFTINFO.FontSizeW;
			if(TFTINFO.Ypos>=320)
				TFTINFO.Ypos=0;
			TFTINFO.Xpos = 0;
		}
		DRIVER_TFT_CHAR(TFTINFO.Xpos, TFTINFO.Ypos, TFTINFO.COLOR, str[i]);
		TFTINFO.Xpos+=TFTINFO.FontSizeL;
		i++;
	}
}
/***************************************************************
FUNCTION:GUIָ괦ʼʾַ
PARAM:ʼx꣬ʼyַ꣬
RETURN:
****************************************************************/
void GUI_DisStrAt(unsigned int x, unsigned int y, unsigned char* str)
{
	unsigned int i=0;

	if(x<240 && y<320)		//ʾ
	{
		TFTINFO.Xpos=x;
		TFTINFO.Ypos=y;
		while(str[i]!='\0')
		{
			if(x>=240)
			{
				y+=TFTINFO.FontSizeW;
				if(y>=320)
					y=0;
				x = 0;
			}
			DRIVER_TFT_CHAR(x, y, TFTINFO.COLOR, str[i]);
			x+=TFTINFO.FontSizeL;
			i++;
		}
	}
}
